# communes admin _express

library(sf)
library(tidyverse)
library(archive)


# rm(list=ls())
url <- "https://wxs.ign.fr/x02uy2aiwjo9bm8ce5plwqmr/telechargement/prepackage/ADMINEXPRESS_SHP_WGS84G_PACK_2022-06-21$ADMIN-EXPRESS_3-1__SHP__FRA_WM_2022-06-21/file/ADMIN-EXPRESS_3-1__SHP__FRA_WM_2022-06-21.7z"

# Téléchargement des fonds de cartes IGN (avant dernier millésime pour être raccord avec les indicateurs, à faire hors RIE)----------
if (!file.exists("extdata/admin_express.7z")) {
  download.file(url, destfile = "extdata/admin_express.7z", method = "curl")
}

# Dezippage
dir.create("extdata/admin_express")
# archive_extract("extdata/admin_express.7z")
archive_extract(archive = "extdata/admin_express.7z", dir = "extdata/admin_express")

# com_admin_exp <- st_read("~/ADMIN-EXPRESS_3-1__SHP__FRA_WM_2022-06-21/ADMIN-EXPRESS/1_DONNEES_LIVRAISON_2022-06-21/ADE_3-1_SHP_WGS84G_FRA/COMMUNE.shp")
# Error: Cannot open "exdata/admin_express/ADMIN-EXPRESS_3-1__SHP__FRA_WM_2022-06-21/ADMIN-EXPRESS_3-1__SHP__FRA_WM_2022-06-21/ADMIN-EXPRESS/1_DONNEES_LIVRAISON_2022-06-21/ADE_3-1_SHP_WGS84G_FRA"; The file doesn't seem to exist

com_admin_exp <- st_read(dsn = "extdata/admin_express/COMMUNE.shp")
# la couche COMMUNE (5 fichiers : .cpg, .dbf, .prj, .shp, .shx) ont été "déplacés" à la main !

save(com_admin_exp, file = "extdata/admin_exp_com.RData")
rm(url)
