library(dplyr)
library(COGiter)
library(datalibaba)

cogifier_it <- function(nom_source = "besoins_chaleur_cerema", ...){
  
  df_source <- importer_data(db = "datamart", schema = "portrait_territoires",
                                  table = paste0("source_", nom_source)) %>% 
    rename_with(.cols = any_of("depcom"), .fn = toupper)
  
  df_cogifie <- cogifier(df_source, ...) %>% 
    mutate(across(.cols = where(is.factor), .fns = as.character))
  
  poster_data(data = df_cogifie,
              db = "datamart",
              schema = "portrait_territoires", 
              table = paste0("cogifiee_", nom_source),
              pk = c("TypeZone", "Zone", "CodeZone", "date"),
              post_row_name = FALSE, 
              overwrite = TRUE,
              droits_schema = TRUE,
              user = "does") 
  
  return(df_cogifie)
}
  
