
# chargement_observatoire_artificialisation

library(magrittr)

rm(list = ls())


# import du fichier de l'observatoire de l'artificialisation ----------

# # Les données de l'observatoire de l'artificialisation 2009-2021 ont été publiées en juillet 2022 :
# # https://artificialisation.developpement-durable.gouv.fr/suivi-consommation-espaces-naf#paragraph--2186
# # La page de téléchargement : https://cerema.app.box.com/v/pnb-action7-indicateurs-ff
# # Le lien de la page de téléchargement du fichier csv : https://cerema.app.box.com/v/pnb-action7-indicateurs-ff/folder/149684581362
# # Un bouton Download permet de charger le fichier obs_artif_conso_com_2009_2021.csv
# # Elles ont donc été téléchargées "à la main" et rangées dans extdata
# 
# obs_artif_conso_com <- readr::read.csv(
#   file = "extdata/obs_artif_conso_com_2009_2021.csv",
#   header = TRUE, 
#   sep = ";",
#   encoding = "UTF-8"
#   )
# 
# # names(obs_artif_conso_com)
# # [1] "idcom"        "idcomtxt"     "idreg"        "idregtxt"     "iddep"        "iddeptxt"     "epci21"       "epci21txt"    "scot"         "aav2020"     
# # [11] "aav2020txt"   "aav2020_typo" "naf09art10"   "art09act10"   "art09hab10"   "art09mix10"   "art09inc10"   "naf10art11"   "art10act11"   "art10hab11"  
# # [21] "art10mix11"   "art10inc11"   "naf11art12"   "art11act12"   "art11hab12"   "art11mix12"   "art11inc12"   "naf12art13"   "art12act13"   "art12hab13"  
# # [31] "art12mix13"   "art12inc13"   "naf13art14"   "art13act14"   "art13hab14"   "art13mix14"   "art13inc14"   "naf14art15"   "art14act15"   "art14hab15"  
# # [41] "art14mix15"   "art14inc15"   "naf15art16"   "art15act16"   "art15hab16"   "art15mix16"   "art15inc16"   "naf16art17"   "art16act17"   "art16hab17"  
# # [51] "art16mix17"   "art16inc17"   "naf17art18"   "art17act18"   "art17hab18"   "art17mix18"   "art17inc18"   "naf18art19"   "art18act19"   "art18hab19"  
# # [61] "art18mix19"   "art18inc19"   "naf19art20"   "art19act20"   "art19hab20"   "art19mix20"   "art19inc20"   "naf20art21"   "art20act21"   "art20hab21"  
# # [71] "art20mix21"   "art20inc21"   "naf09art21"   "art09act21"   "art09hab21"   "art09mix21"   "art09inc21"   "artcom2020"   "pop13"        "pop18"       
# # [81] "pop1318"      "men13"        "men18"        "men1318"      "emp13"        "emp18"        "emp1318"      "mepart1318"   "menhab1318"   "artpop1318"  
# # [91] "surfcom2021" 


# Les données de l'observatoire de l'artificialisation 2009-2022 ont été publiées en juillet 2023 :
# https://cerema.app.box.com/v/pnb-action7-indicateurs-ff
# un clic droit sur le répertoire "donnees nationales conso espaces" fait apparaître une popup de téléchargement 
# qui permet de récupérer le fichier "donnees nationales conso espaces.zip" qu'on range dans extdata et qu'on dézipe à la main

obs_artif_conso_com <- utils::read.csv(
  file = "extdata/donnees nationales conso espaces/obs_artif_conso_com_2009_2022.csv",
  header = TRUE, 
  sep = ";", 
  encoding = "UTF-8"
  )

# names(obs_artif_conso_com)
# [1] "idcom"        "idcomtxt"     "idreg"        "idregtxt"     "iddep"        "iddeptxt"     "epci22"       "epci22txt"    "scot"        
# [10] "aav2020"      "aav2020txt"   "aav2020_typo" "naf09art10"   "art09act10"   "art09hab10"   "art09mix10"   "art09rou10"   "art09fer10"  
# [19] "art09inc10"   "naf10art11"   "art10act11"   "art10hab11"   "art10mix11"   "art10rou11"   "art10fer11"   "art10inc11"   "naf11art12"  
# [28] "art11act12"   "art11hab12"   "art11mix12"   "art11rou12"   "art11fer12"   "art11inc12"   "naf12art13"   "art12act13"   "art12hab13"  
# [37] "art12mix13"   "art12rou13"   "art12fer13"   "art12inc13"   "naf13art14"   "art13act14"   "art13hab14"   "art13mix14"   "art13rou14"  
# [46] "art13fer14"   "art13inc14"   "naf14art15"   "art14act15"   "art14hab15"   "art14mix15"   "art14rou15"   "art14fer15"   "art14inc15"  
# [55] "naf15art16"   "art15act16"   "art15hab16"   "art15mix16"   "art15rou16"   "art15fer16"   "art15inc16"   "naf16art17"   "art16act17"  
# [64] "art16hab17"   "art16mix17"   "art16rou17"   "art16fer17"   "art16inc17"   "naf17art18"   "art17act18"   "art17hab18"   "art17mix18"  
# [73] "art17rou18"   "art17fer18"   "art17inc18"   "naf18art19"   "art18act19"   "art18hab19"   "art18mix19"   "art18rou19"   "art18fer19"  
# [82] "art18inc19"   "naf19art20"   "art19act20"   "art19hab20"   "art19mix20"   "art19rou20"   "art19fer20"   "art19inc20"   "naf20art21"  
# [91] "art20act21"   "art20hab21"   "art20mix21"   "art20rou21"   "art20fer21"   "art20inc21"   "naf21art22"   "art21act22"   "art21hab22"  
# [100] "art21mix22"   "art21rou22"   "art21fer22"   "art21inc22"   "naf09art22"   "art09act22"   "art09hab22"   "art09mix22"   "art09inc22"  
# [109] "art09rou22"   "art09fer22"   "artcom0922"   "pop13"        "pop19"        "pop1319"      "men13"        "men19"        "men1319"     
# [118] "emp13"        "emp19"        "emp1319"      "mepart1319"   "menhab1319"   "artpop1319"   "surfcom2022" 


# Au 22/02/2024 : pas de données plus récentes.


# calcul des indicateurs communaux ----------- 
observatoire_artificialisation <- obs_artif_conso_com %>% 
  dplyr::select(
    -c(idcomtxt,
       idreg,
       idregtxt,
       iddep,
       iddeptxt,
       # epci21,
       # epci21txt,
       epci22,
       epci22txt,
       scot,
       aav2020,
       aav2020txt,
       aav2020_typo
       # libaav2020,
       # cateaav2020
       )
    ) %>%
  dplyr::select(
    -starts_with("nafart"),
    -starts_with("artact"),
    -starts_with("arthab"),
    -starts_with("artmix"),
    -starts_with("artinc"),
    -starts_with("artcom"),
    -starts_with("pop"),
    -starts_with("men"),
    -starts_with("emp"),
    -starts_with("mepart"),
    -starts_with("menhab"),
    -starts_with("artpop"),
    -starts_with("surfcom")
    ) %>%
  tidyr::pivot_longer(cols = contains("art"), names_to = "variable", values_to = "valeur") %>%
  dplyr::mutate(
    annee_1 = as.numeric(stringr::str_sub(variable, 4, 5)) + 2000,
    annee_2 = as.numeric(stringr::str_sub(variable, 9, 10)) + 2000,
    variable = paste(stringr::str_sub(variable, 1, 3), stringr::str_sub(variable, 6, 8))
    ) %>% 
  dplyr::mutate(
    variable = dplyr::case_when(
      variable == "naf art" ~ "flux_naf_artificialisation_total",
      variable == "art act" ~ "flux_naf_artificialisation_activite",
      variable == "art hab" ~ "flux_naf_artificialisation_habitation",
      variable == "art mix" ~ "flux_naf_artificialisation_mixte",
      variable == "art rou" ~ "flux_naf_artificialisation_route",
      variable == "art fer" ~ "flux_naf_artificialisation_fer",
      variable == "art inc" ~ "flux_naf_artificialisation_inconnue"
      )
    ) %>% 
  dplyr::mutate(diff = annee_2 - annee_1) %>% 
  dplyr::filter(diff == 1) %>% 
  dplyr::select(-diff) %>% 
  dplyr::mutate(date = lubridate::dmy(paste("01-01", annee_2, sep = "-"))) %>%
  dplyr::select(-c(annee_1, annee_2)) %>% 
  dplyr::rename(depcom = idcom) %>% 
  dplyr::mutate(
    depcom = as.factor(depcom), 
    variable = as.factor(variable), 
    valeur = as.numeric(valeur)
    ) %>%
  tidyr::complete(depcom, date, variable, fill = list(valeur = 0), explicit = FALSE) %>% 
  tidyr::pivot_wider(names_from = variable, values_from = valeur)


# complétude de la liste des communes -------
liste_COG_2023 <- COGiter::communes %>%
  dplyr::select(depcom = DEPCOM) %>%
  dplyr::pull() %>% 
  as.character() # 34945 obs

source_observatoire_artificialisation <- observatoire_artificialisation %>% 
  dplyr::mutate(depcom = forcats::fct_expand(depcom, liste_COG_2023)) %>% 
  tidyr::complete(
    depcom, date, fill = list(
      flux_naf_artificialisation_activite = 0,
      flux_naf_artificialisation_fer = 0,
      flux_naf_artificialisation_habitation = 0,
      flux_naf_artificialisation_inconnue = 0,
      flux_naf_artificialisation_mixte = 0,
      flux_naf_artificialisation_route = 0,
      flux_naf_artificialisation_total = 0
      )
    )

# versement et commentaires dans sgbd -------
source("R/poster_documenter_data.R", encoding = "UTF-8")
poster_documenter_it(
  df = source_observatoire_artificialisation ,
  nom_table_sgbd = "source_observatoire_artificialisation", 
  comm_source_en_plus = ""
  )
