
# chargement_prec_nrj

# vulnérabilité énergétqiue - AT44 INSEE-SOES

# librairies --------------
library(dplyr)
library(tidyr)
library(purrr)
library(lubridate)
library(forcats)
library(datalibaba)
library(googlesheets4)
library(stringr)

rm(list=ls())


# chargement data -----------
# precarite_energetique <- read.sas7bdat("extdata/AT44_prec_energ/baseat44compl.sas7bdat") 
# load("extdata/AT44_prec_energ/baseat44compl.RData")

precarite_energetique <- readRDS("extdata/baseat44compl.rds")

prec_nrj <- precarite_energetique %>%
  select(depcom, pondl, starts_with("nbpers14"), starts_with("energie"), starts_with("prec")) %>% 
  as_tibble() %>%
  group_by(depcom) %>%
  summarise(nb_men = sum(pondl), pop2011 = sum(nbpers14p + nbpers14m), nb_men_prec_lgt = sum(pondl * preclog), nb_men_prec_carbu = sum(pondl * precdp),
            nb_pers_prec_lgt = sum(pondl*preclog*(nbpers14p+nbpers14m)), nb_pers_prec_carbu=sum(pondl*precdp*(nbpers14p+nbpers14m)),
            energiea = weighted.mean(energiea, pondl), energieb = weighted.mean(energieb, pondl), 
            energiec = weighted.mean(energiec, pondl), energied = weighted.mean(energied, pondl),
            energiee = weighted.mean(energiee, pondl), energief = weighted.mean(energief, pondl),
            energieg = weighted.mean(energieg, pondl), energieh = weighted.mean(energieh, pondl),
            energiei = weighted.mean(energiei, pondl)) %>%
  ungroup() %>%
  mutate(across(starts_with("energie"), ~ nb_men*./100),  # transformation des % en nombre de logements
         date = make_date(2014, 01, 01), 
         across(where(is_character), as.factor),
         across(where(is.factor), fct_drop))


# versement dans le sgbd/datamart.portrait_territoires -------------

source("R/poster_documenter_data.R")
poster_documenter_it(df = prec_nrj, nom_table_sgbd = "source_prec_nrj", comm_source_en_plus = "Investissement AT 44.")


rm(list=ls())
