
# chargement_rsvero

# librairies ---------
library(readxl)
library(tidyverse)
library(lubridate)
library(COGiter)


rm(list = ls())


# chargement data et calcul --------
path <- 'extdata/rsvero_parcs_2020_reg52_epci.xlsx'

parc_auto <- path %>% 
  excel_sheets() %>%
  set_names() %>%
  map(read_excel, path = path)

rsvero <- bind_rows(parc_auto,.id = "type_de_parc") %>% 
  mutate(variable = str_c(str_to_lower(type_de_parc),"_",str_to_lower(energie)) %>% 
           str_replace_all(" ","_") %>% 
           iconv(from="UTF-8",to="ASCII//TRANSLIT"),
         date = ymd('2020-06-01')) %>% 
  select(depcom = COMM, date, variable, valeur = parc2020) %>% 
  group_by(depcom, date, variable) %>% 
  summarise(valeur = sum(valeur)) %>% 
  ungroup() %>% 
  complete(depcom, date, variable, fill = list(valeur =0)) %>% 
  pivot_wider(names_from = variable, values_from = valeur) %>% 
  mutate(across(where(is.character), as.factor))

# problemes sur les TCP : 85146, 85194, 49345, 49307, 49218, 49092
# manque L'Ile d'Yeu !

com <- communes %>% 
  filter(grepl("52",REGIONS_DE_L_EPCI)) %>% 
  select(depcom = DEPCOM) %>% 
  mutate_if(is.factor,as.character)

annee <- select(rsvero, date) %>% 
  unique()

com_annee <- merge(com, annee)

source_rsvero <- left_join(com_annee, rsvero)


# versement dans le sgbd/datamart.portrait_territoires et metdonnées -------------
source("R/poster_documenter_data.R", encoding = "UTF-8")
poster_documenter_it(df = source_rsvero ,
                     nom_table_sgbd = "source_rsvero", 
                     comm_source_en_plus = "")
