
# chargement_superficie_territoires

rm(list = ls())

library(magrittr)

annee_cogiter <- "2023"

# calcul -----------
superficie_territoires <- COGiter::communes_geo %>%
  sf::st_drop_geometry() %>% 
  dplyr::mutate(
    date = lubridate::ymd(paste0(annee_cogiter, "0101")),
    variable = "aire_du_territoire_en_m2",
    AREA = as.numeric(AREA)
    ) %>% 
  dplyr::select(depcom = DEPCOM, date, variable, valeur = AREA) %>% 
  tidyr::complete(depcom, date, variable, fill = list(valeur = 0)) %>% 
  tidyr::pivot_wider(names_from = variable, values_from = valeur)

# versement dans le sgbd/datamart.portrait_territoires -------------
source("R/poster_documenter_data.R")
poster_documenter_it(
  df = superficie_territoires, 
  nom_table_sgbd = "source_superficie_territoires", 
  comm_source_en_plus = ""
  )
