
# indicateur_bimotor_menages
rm(list = ls())

# librairies ----------
library(dplyr)
library(tidyr)
library(datalibaba)
source("R/poster_documenter_ind.R")


# Chargement data ---------
cogifiee_lgt_rgp_insee <- importer_data(table = "cogifiee_lgt_rgp_insee", schema = "portrait_territoires", db = "datamart", user = "does")

# calcul ------
indicateur_bimotor_menages <- cogifiee_lgt_rgp_insee %>% 
  select(TypeZone, Zone, CodeZone, date, rp, rp.voit2p) %>% 
  mutate(taux_men_bimotor = rp.voit2p / rp * 100) %>%
  select(-rp, -rp.voit2p)


# chargement dans le SGBD des indicateurs calculés et des commentaires
poster_documenter_ind(df = indicateur_bimotor_menages, nom_table_sgbd = "indicateur_bimotor_menages", 
                      comm_source_en_plus = "", nom_script_sce = "indicateur_bimotor_menages")

rm(list=ls())

