
# indicateur_captage_prioritaire_protection_action

# librairies ----------
library(datalibaba)
library(tidyverse)

rm(list=ls())


cogifiee_captage_prioritaire_protection_action <- importer_data(db = "datamart",
                                                                schema = "portrait_territoires",
                                                                table = "cogifiee_captage_prioritaire_protection_action")

indicateur_captage_prioritaire_protection_action <- cogifiee_captage_prioritaire_protection_action %>% 
  mutate(part_protection_captage = round(surf_protection_captage/surf_calculee_en_m2*100, digits = 2)) %>% 
  select(TypeZone, Zone, CodeZone, date, part_protection_captage)


# versement dans le sgbd/datamart.portrait_territoires et commentaires-------------
source("R/poster_documenter_ind.R")
poster_documenter_ind(df = indicateur_captage_prioritaire_protection_action, 
                      nom_table_sgbd = "indicateur_captage_prioritaire_protection_action", 
                      nom_script_sce = "indicateur_captage_prioritaire_protection_action",
                      comm_source_en_plus = "")

rm(list=ls())
