
# indicateur_couverture_sage

rm(list = ls())

cogifiee_couverture_sage <- datalibaba::importer_data(
  db = "datamart",
  schema = "portrait_territoires",
  table = "cogifiee_couverture_sage"
  )

indicateur_couverture_sage <- cogifiee_couverture_sage %>% 
  dplyr::mutate(
    part_territoire_sage_mis_en_oeuvre = round(mis_en_oeuvre/surf_calculee_en_m2*100, digits = 2),
    part_territoire_sage_elaboration = round(elaboration/surf_calculee_en_m2*100, digits = 2),
    part_territoire_hors_sage  = round(hors_sage/surf_calculee_en_m2*100, digits = 2)
    ) %>% 
  dplyr::select(-c(elaboration, hors_sage, mis_en_oeuvre, surf_calculee_en_m2)) %>% 
  dplyr::mutate(
    part_territoire_sage_mis_en_oeuvre = ifelse(part_territoire_sage_mis_en_oeuvre > 100, 100, part_territoire_sage_mis_en_oeuvre),
    part_territoire_sage_elaboration = ifelse(part_territoire_sage_elaboration > 100, 1000, part_territoire_sage_elaboration),
    part_territoire_hors_sage = ifelse(part_territoire_hors_sage > 100, 100, part_territoire_hors_sage)
    )

# chargement des indicateurs calculés et des commentaires
source("R/poster_documenter_ind.R")
poster_documenter_ind(
  df = indicateur_couverture_sage,
  nom_table_sgbd = "indicateur_couverture_sage", 
  nom_script_sce = "indicateur_couverture_sage",
  comm_source_en_plus = ""
  )

rm(list=ls())

