
# indicateur_pci_lgt_rgp_insee

library(magrittr)

rm(list = ls())

# variables et identifiants de connexion ----------
base <- "datamart"
schema <- "portrait_territoires"
tab1 <- "cogifiee_pci"
tab2 <- "cogifiee_lgt_rgp_insee"
tab_indicateur <- "indicateur_pci_lgt_rgp_insee"

# chargement des données cogifiees -------------
pci <- datalibaba::importer_data(
  db = base,
  schema = schema,
  table = tab1
  )
# unique(pci$date)
# [1] "2011-01-01" "2012-01-01" "2013-01-01" "2014-01-01" "2015-01-01" "2017-01-01" "2018-01-01" "2019-01-01" "2020-01-01"

lgt_rgp_insee <- datalibaba::importer_data(
  db = base,
  schema = schema,
  table = tab2
  )
# unique(lgt_rgp_insee$date)
# [1] "2010-01-01" "2015-01-01" "2021-01-01"

# calcul de l'indicateur ------------
pci <- pci %>%
  dplyr::select(TypeZone, Zone, CodeZone, date, surf_bati_total)

lgt_rgp_insee <- lgt_rgp_insee %>%
  dplyr::select(TypeZone, Zone, CodeZone, date, log) %>%
  dplyr::mutate(date = date + 1)

indicateur_pci_lgt_rgp_insee <- dplyr::left_join(
  pci, 
  lgt_rgp_insee
  ) %>%
  dplyr::mutate(surf_bati_par_logt = round(surf_bati_total/log*10000, digits = 0)) %>%
  dplyr::select(-c(surf_bati_total, log)) %>%
  dplyr::filter(!is.na(surf_bati_par_logt))
unique(indicateur_pci_lgt_rgp_insee$date)
# [1] "2015-01-01"

# versement dans le sgbd/datamart.portrait_territoires et metadonnées -------------
source("R/poster_documenter_ind.R", encoding = "UTF-8")
poster_documenter_ind(
  df = indicateur_pci_lgt_rgp_insee,
  nom_table_sgbd = "indicateur_pci_lgt_rgp_insee",
  comm_source_en_plus = ""
  )
