
# indicateur_pci_population_legale

library(magrittr)

rm(list = ls())

# variables et identifiants de connexion ----------
base <- "datamart"
schema <- "portrait_territoires"
tab1 <- "cogifiee_pci"
tab2 <- "cogifiee_population_legale"
tab_indicateur <- "indicateur_pci_population_legale"


# chargement des données cogifiees -------------
pci <- datalibaba::importer_data(
  db = base,
  schema = schema,
  table = tab1
  )
# unique(pci$date)
# [1] "2011-01-01" "2012-01-01" "2013-01-01" "2014-01-01" "2015-01-01" "2017-01-01" "2018-01-01" "2019-01-01" "2020-01-01"

population_legale <- datalibaba::importer_data(
  db = base,
  schema = schema,
  table = tab2
  )
# unique(population_legale$date)
# [1] "1968-01-01" "1975-01-01" "1982-01-01" "1990-01-01" "1999-01-01" "2006-01-01" "2007-01-01" "2008-01-01" "2009-01-01" "2010-01-01"
# [11] "2011-01-01" "2012-01-01" "2013-01-01" "2014-01-01" "2015-01-01" "2016-01-01" "2017-01-01" "2018-01-01" "2019-01-01" "2020-01-01"
# [21] "2021-01-01"

# calcul de l'indicateur -----------
indicateur_pci_population_legale <- dplyr::left_join(
  pci %>% dplyr::select(TypeZone, Zone, CodeZone, date, surf_bati_total),
  population_legale
  ) %>% 
  dplyr::mutate(
    surf_bati_par_habt = round(surf_bati_total/population_municipale*10000, digits = 0)
    ) %>% # conversion en m²
  dplyr::select(-c(surf_bati_total, population_municipale)) %>% 
  dplyr::filter(!is.na(surf_bati_par_habt))
# unique(indicateur_pci_population_legale$date)
# [1] "2011-01-01" "2012-01-01" "2013-01-01" "2014-01-01" "2015-01-01" "2017-01-01" "2018-01-01" "2019-01-01" "2020-01-01"

# versement dans le sgbd/datamart.portrait_territoires et metdonnées -------------
source("R/poster_documenter_ind.R", encoding = "UTF-8")
poster_documenter_ind(
  df = indicateur_pci_population_legale,
  nom_table_sgbd = "indicateur_pci_population_legale",
  comm_source_en_plus = ""
  )
