
# indicateur_prec_nrj

# indicateurs précarité énergétique du kit data PCAET
# pe_lgt
# pe_carbu
# nb_lgt_FGH
# indicateurs de diffusabilité = pop2011 > 27500hab, pour variables précédemment chargées
rm(list = ls())

# librairies ----------
library(dplyr)
library(tidyr)
library(datalibaba)
source("R/poster_documenter_ind.R")


# chargement data ----------

cogifiee_prec_nrj0 <- importer_data(table = "cogifiee_prec_nrj", schema = "portrait_territoires", db = "datamart", user = "does")
cogifiee_prec_nrj <- pivot_longer(cogifiee_prec_nrj0, cols = where(is.numeric),
                                  names_to = "variable", values_to = "valeur")


# calcul ----------
indicateur_prec_nrj <- cogifiee_prec_nrj %>% 
  pivot_wider(names_from = variable, values_from = valeur) %>%
  mutate(diffusable = (pop2011 >= 27500),
         pe_lgt = if_else(diffusable, nb_men_prec_lgt / nb_men * 100, NA_real_),
         pe_carbu = if_else(diffusable, nb_men_prec_carbu / nb_men * 100, NA_real_),
         nb_men_prec_carbu = if_else(diffusable, nb_men_prec_carbu, NA_real_),
         nb_men_prec_lgt = if_else(diffusable, nb_men_prec_lgt, NA_real_),
         nb_pers_prec_carbu = if_else(diffusable, nb_pers_prec_carbu, NA_real_),
         nb_pers_prec_lgt = if_else(diffusable, nb_pers_prec_lgt, NA_real_),
         nb_lgt_FGH = energief + energieg + energieh + energiei,
         across(where(is.factor), as.character)) %>% 
  select(contains("zone"), contains("Zone"), date, contains("_men_"), contains("_pers_"), diffusable:nb_lgt_FGH)

# chargement dans le SGBD des indicateurs calculés et des commentaires-------
poster_documenter_ind(df = indicateur_prec_nrj, nom_table_sgbd = "indicateur_prec_nrj", 
                      comm_source_en_plus = "", nom_script_sce = "indicateur_prec_nrj")

rm(list=ls())

