# indicateur_prod_elec_renouvelable

# 2 indicateurs : total elec renouvelable produite et calcul % enr dans conso

rm(list = ls())

# librairies ------
library(dplyr)
library(tidyr)
library(dplyr)
library(COGiter)
library(datalibaba)
source("R/poster_documenter_ind.R")



# chargement data ----------
cogifiee_conso_elec_179 <- importer_data(db = "datamart", schema = "portrait_territoires", table = "cogifiee_conso_elec_179", user = "does")

conso_elec_179 <- pivot_longer(cogifiee_conso_elec_179, 
                               cols = !c(contains("Zone"), contains("zone"), date),
                               names_to = "variable", values_to = "valeur")

cogifiee_prod_elec_renouv <- importer_data(db = "datamart", schema = "portrait_territoires", table = "cogifiee_prod_elec_renouv", user = "does")

prod_elec_renouv <- pivot_longer(cogifiee_prod_elec_renouv,
                                 cols =  -c(contains("Zone"), contains("zone"), date),
                                 names_to = "variable", values_to = "valeur") %>% 
  filter(date <= max(conso_elec_179$date))


# calcul --------
conso_elec_179 <- filter(conso_elec_179, variable == "conso_elec_gwh") %>%
  pivot_wider(names_from = variable, values_from = valeur)

indicateur_prod_elec_renouv <- prod_elec_renouv %>% 
  filter(grepl("kWh", variable)) %>% 
  group_by(date, CodeZone, TypeZone, Zone) %>%
  summarise(GWh_enr_elec=(sum(valeur, na.rm = TRUE)/1000000) %>% round(3), .groups = "drop") %>%
  left_join(conso_elec_179) %>%
  mutate(part_elec_renouv = GWh_enr_elec/conso_elec_gwh*100) %>%
  select(-conso_elec_gwh) %>% 
  mutate_if(is.factor, as.character)


# versement dans le sgbd/datamart.portrait_territoires et documentation-------------
poster_documenter_ind(df = indicateur_prod_elec_renouv, nom_table_sgbd = "indicateur_prod_elec_renouv", 
                      comm_source_en_plus = "")

rm(list=ls())
