
# indicateur_protection_naturelle

library(magrittr)

rm(list = ls())

cogifiee_protection_naturelle <- datalibaba::importer_data(
  db = "datamart",
  schema = "portrait_territoires",
  table = "cogifiee_protection_naturelle"
  )

indicateur_protection_naturelle <- cogifiee_protection_naturelle %>% 
  dplyr::mutate(
    part_protection_forte = round(surf_protection_forte/surf_calculee_en_m2*100, digits = 2),
    part_protection_elargie = round(surf_protection_elargie/surf_calculee_en_m2*100, digits = 2)
    ) %>%
  dplyr::select(
    -surf_calculee_en_m2,
    -surf_protection_forte,
    -surf_protection_elargie
    )

# versement dans le sgbd/datamart.portrait_territoires et metadonnées ---------
source("R/poster_documenter_ind.R", encoding = "UTF-8")
poster_documenter_ind(
  df = indicateur_protection_naturelle,
  nom_table_sgbd = "indicateur_protection_naturelle",
  comm_source_en_plus = ""
  )
  