# indicateur_sitadel

# librairies ---------
library(datalibaba)
library(googlesheets4)
library(tidyverse)

rm(list=ls())

# chargement data ---------------
cogifiee_sitadel <- importer_data(table = "cogifiee_sitadel",
                                  schema = "portrait_territoires",
                                  db = "datamart",
                                  user = "does")

# calcul -------
indicateur_sitadel <- cogifiee_sitadel %>% 
  mutate(part_lgt_aut_collectifs = nb_lgt_aut_collectifs / nb_lgt_aut_total * 100,
         part_lgt_aut_individuels = (nb_lgt_aut_individuels_purs + nb_lgt_aut_individuels_groupes) / nb_lgt_aut_total * 100,
         part_lgt_aut_en_residence = nb_lgt_aut_en_residence / nb_lgt_aut_total * 100) %>% 
  select(TypeZone, Zone, CodeZone, date, starts_with("part_")) %>%
  mutate(across(where(is.factor), as.character),
         across(where(is.numeric), ~round(.x, 1)),
         across(where(is.numeric), ~na_if(.x, NaN)))

# versement dans le sgbd/datamart.portrait_territoires et metadonnées -------------
source("R/poster_documenter_ind.R", encoding = "UTF-8")
poster_documenter_ind(df = indicateur_sitadel,
                      nom_table_sgbd = "indicateur_sitadel",
                      comm_source_en_plus = "Chargement des donn\u00e9es issues de Geokit3")

rm(list=ls())

