
# indicateur_territoire_protege

library(magrittr)

rm(list = ls())

cogifiee_territoire_protege <- datalibaba::importer_data(
  table = "cogifiee_territoire_protege",
  schema = "portrait_territoires",
  db = "datamart",
  user = "does"
  )

indicateur_territoire_protege <- dplyr::mutate(
  cogifiee_territoire_protege,
  part_territoire_protege_total = round(surf_territoire_protege/surf_calculee_en_m2*100, digits = 2),
  part_territoire_protege_apb = round(surf_territoire_protege_apb/surf_calculee_en_m2*100, digits = 2),
  part_territoire_protege_pnr = round(surf_territoire_protege_pnr/surf_calculee_en_m2*100, digits = 2),
  part_territoire_protege_rnn = round(surf_territoire_protege_rnn/surf_calculee_en_m2*100, digits = 2),
  part_territoire_protege_rnr = round(surf_territoire_protege_rnr/surf_calculee_en_m2*100, digits = 2),
  part_territoire_protege_sic = round(surf_territoire_protege_sic/surf_calculee_en_m2*100, digits = 2),
  part_territoire_protege_zps = round(surf_territoire_protege_zps/surf_calculee_en_m2*100, digits = 2)
  ) %>% 
  dplyr::select(
    -c(surf_calculee_en_m2, 
       surf_territoire_protege,
       surf_territoire_protege_apb, 
       surf_territoire_protege_pnr,
       surf_territoire_protege_rnn, 
       surf_territoire_protege_rnr,
       surf_territoire_protege_sic, 
       surf_territoire_protege_zps)
    )


# chargement dans le SGBD des indicateurs calculés et des commentaires
source("R/poster_documenter_ind.R")
poster_documenter_ind(
  df = indicateur_territoire_protege, 
  nom_table_sgbd = "indicateur_territoire_protege", 
  comm_source_en_plus = ""
  )

rm(list=ls())